%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                      PSG Type    PSG Object             Location in Problem Statement                                         Class
%matrix_obj_data             data        matrix_obj             linear(matrix_obj)                                                    double
%matrix_obj_vars             vars        matrix_obj             linear(matrix_obj)                                                    cell
%matrix_multilin_data        data        matrix_multilin        linearmulti(matrix_multilin)                                          double
%matrix_multilin_vars        vars        matrix_multilin        linearmulti(matrix_multilin)                                          cell
%matrix_mu_teta_benchmark    bench       matrix_mu_teta         prmulti_pen_ni_g(parameter_alpha, matrix_mu_teta, matrix_var_teta)    double
%matrix_mu_teta_data         data        matrix_mu_teta         prmulti_pen_ni_g(parameter_alpha, matrix_mu_teta, matrix_var_teta)    double
%matrix_mu_teta_vars         vars        matrix_mu_teta         prmulti_pen_ni_g(parameter_alpha, matrix_mu_teta, matrix_var_teta)    cell
%matrix_var_teta_data        data        matrix_var_teta        prmulti_pen_ni_g(parameter_alpha, matrix_mu_teta, matrix_var_teta)    double
%matrix_var_teta_vars        vars        matrix_var_teta        prmulti_pen_ni_g(parameter_alpha, matrix_mu_teta, matrix_var_teta)    cell
%vector_right_data           data        vector_right           Constraint: <= vector_right                                           double
%parameter_bound_data        data        parameter_bound        Constraint: <= parameter_bound                                        double
%parameter_alpha_data        data        parameter_alpha        prmulti_pen_ni_g(parameter_alpha, matrix_mu_teta, matrix_var_teta)    double
%parameter_bound_1_data      data        parameter_bound_1      Box: >= parameter_bound_1, <= parameter_bound_2, types =1             double
%parameter_bound_2_data      data        parameter_bound_2      Box: >= parameter_bound_1, <= parameter_bound_2, types =1             double
%parameter_bound_3_data      data        parameter_bound_3      n/a                                                                   double
%parameter_precision_data    data        parameter_precision    Solver: precision = parameter_precision                               char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_obj_data,matrix_obj_vars,matrix_multilin_data,matrix_multilin_vars,matrix_mu_teta_benchmark,matrix_mu_teta_data,matrix_mu_teta_vars,matrix_var_teta_data,matrix_var_teta_vars,vector_right_data,parameter_bound_data,parameter_alpha_data,parameter_bound_1_data,parameter_bound_2_data,parameter_bound_3_data,parameter_precision_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_obj',matrix_obj_data,matrix_obj_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_multilin',matrix_multilin_data,matrix_multilin_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_mu_teta',matrix_mu_teta_data,matrix_mu_teta_vars,matrix_mu_teta_benchmark,[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_var_teta',matrix_var_teta_data,matrix_var_teta_vars,[],[]);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_right',vector_right_data);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'maximize',...
'  linear(matrix_obj)',...
'Constraint: <= vector_right',...
'  linearmulti(matrix_multilin)',...
'Constraint: <= parameter_bound',...
'  prmulti_pen_ni_g(parameter_alpha, matrix_mu_teta, matrix_var_teta)',...
'Box: >= parameter_bound_1, <= parameter_bound_2, types =1',...
'Solver: precision = parameter_precision',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_precision',parameter_precision_data);
problem_statement = strrep(problem_statement,'parameter_bound_1',num2str(parameter_bound_1_data));
problem_statement = strrep(problem_statement,'parameter_bound_2',num2str(parameter_bound_2_data));
problem_statement = strrep(problem_statement,'parameter_bound_3',num2str(parameter_bound_3_data));
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));
problem_statement = strrep(problem_statement,'parameter_alpha',num2str(parameter_alpha_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

