%This Example for using users m-function Optimization_subroutine.m was created automatically by PSG Toolbox.

%Function description:

%maximize
%linear(matrix_obj)
%Constraint: <= vector_right
%linearmulti(matrix_multilin)
%Constraint: <= parameter_bound
%prmulti_pen_ni_g(parameter_alpha, matrix_mu_teta, matrix_var_teta)
%Box: >= parameter_bound_1, <= parameter_bound_2, types =1
%Solver: precision = parameter_precision
%
%Input variables:
%
%Inputs                      PSG Type    PSG Object             Location in Problem Statement                                         Class
%matrix_obj_data             data        matrix_obj             linear(matrix_obj)                                                    double
%matrix_obj_vars             vars        matrix_obj             linear(matrix_obj)                                                    cell
%matrix_multilin_data        data        matrix_multilin        linearmulti(matrix_multilin)                                          double
%matrix_multilin_vars        vars        matrix_multilin        linearmulti(matrix_multilin)                                          cell
%matrix_mu_teta_benchmark    bench       matrix_mu_teta         prmulti_pen_ni_g(parameter_alpha, matrix_mu_teta, matrix_var_teta)    double
%matrix_mu_teta_data         data        matrix_mu_teta         prmulti_pen_ni_g(parameter_alpha, matrix_mu_teta, matrix_var_teta)    double
%matrix_mu_teta_vars         vars        matrix_mu_teta         prmulti_pen_ni_g(parameter_alpha, matrix_mu_teta, matrix_var_teta)    cell
%matrix_var_teta_data        data        matrix_var_teta        prmulti_pen_ni_g(parameter_alpha, matrix_mu_teta, matrix_var_teta)    double
%matrix_var_teta_vars        vars        matrix_var_teta        prmulti_pen_ni_g(parameter_alpha, matrix_mu_teta, matrix_var_teta)    cell
%vector_right_data           data        vector_right           Constraint: <= vector_right                                           double
%parameter_bound_data        data        parameter_bound        Constraint: <= parameter_bound                                        double
%parameter_alpha_data        data        parameter_alpha        prmulti_pen_ni_g(parameter_alpha, matrix_mu_teta, matrix_var_teta)    double
%parameter_bound_1_data      data        parameter_bound_1      Box: >= parameter_bound_1, <= parameter_bound_2, types =1             double
%parameter_bound_2_data      data        parameter_bound_2      Box: >= parameter_bound_1, <= parameter_bound_2, types =1             double
%parameter_bound_3_data      data        parameter_bound_3      n/a                                                                   double
%parameter_precision_data    data        parameter_precision    Solver: precision = parameter_precision                               char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB_Stan\ready\Optimal Tests Selection\data_problem_stochastic_model_short\Optimization_subroutine_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function Optimization_subroutine:

[solution_str,outargstruc_arr] = Optimization_subroutine(matrix_obj_data,matrix_obj_vars,matrix_multilin_data,matrix_multilin_vars,matrix_mu_teta_benchmark,matrix_mu_teta_data,matrix_mu_teta_vars,matrix_var_teta_data,matrix_var_teta_vars,vector_right_data,parameter_bound_data,parameter_alpha_data,parameter_bound_1_data,parameter_bound_2_data,parameter_bound_3_data,parameter_precision_data);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
